//+------------------------------------------------------------------+
//|                                      BBollinger_Sortie_Chart.mq4 |
//|                                                                  |
//|                                                                  |
//+------------------------------------------------------------------+
#property indicator_chart_window
#property indicator_buffers 8
#property indicator_color1 LightBlue 
#property indicator_color2 LightSkyBlue 
#property indicator_color3 LightSeaGreen
#property indicator_color4 Pink
#property indicator_color5  Lime
#property indicator_color6 Orange
#property indicator_color7 Lime
#property indicator_color8 Orange
#property indicator_width1 2 
#property indicator_width2 2 
#property indicator_width3 2 
#property indicator_width4 2 
#property indicator_width5 1 
#property indicator_width6 1 
#property indicator_width7 2 
#property indicator_width8 2

//---- indicator parameters
extern int    BBPer     =  20;
extern double BBDev     =  2.0;
extern int    BBShift   =  0;
extern int    BBPrix    =  0;
//iCustom(NULL,0,"BBollinger_Sortie_Chart" BBPer,BBDev,BBShift,BBPrix, x,1);  

//extern int    Meth            =  0;
//extern double  stop_SL         =  25;
//extern double  stop_TP         =  25;
//  extern double small  = 25;
 // extern double big    = 50;  

//extern int flaten = 50;
//---- buffers
double Moving_haut[];
double Upper[];
double Lower[];
double Moving_bas[];
double Fleche_up_1[];
double Fleche_down_1[];
double Fleche_up_2[];
double Fleche_down_2[];
static int prevtime = 0;

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- indicators
  // IndicatorBuffers(6);
  string Nom; Nom = "BBollinger_Sortie_chart"; 
  IndicatorShortName(Nom);
    IndicatorDigits(Digits+2);
  
   SetIndexStyle(0,DRAW_NONE);//LINE, STYLE_SOLID, 2);
   SetIndexBuffer(0,Moving_haut );
   
   SetIndexStyle(1,DRAW_LINE, STYLE_SOLID, 2);
   SetIndexBuffer(1,Upper);
   
   SetIndexStyle(2,DRAW_LINE, STYLE_SOLID, 2);
   SetIndexBuffer(2,Lower);
   
   SetIndexBuffer(3,Moving_bas);
   SetIndexStyle(3,DRAW_NONE);//LINE,  STYLE_SOLID, 2 );
 
   
   SetIndexBuffer(4, Fleche_up_1 );
   SetIndexStyle(4, DRAW_ARROW);//, STYLE_SOLID,2);
   SetIndexArrow(4,233);
   SetIndexEmptyValue(4,0.0);
   SetIndexLabel(4,"principal");
  
   SetIndexBuffer(5,Fleche_down_1);
   SetIndexStyle(5, DRAW_ARROW);//, STYLE_SOLID,2);
   SetIndexArrow(5,234);
   SetIndexEmptyValue(5,0.0);// SI ON OUBLIE LE EMPTY VALUE NE MARCHE PAS
   SetIndexLabel(5,"intermediaire");
 
   SetIndexBuffer(6, Fleche_up_2 );
   SetIndexStyle(6, DRAW_ARROW);//, STYLE_SOLID,2);
   SetIndexArrow(6,233);
   SetIndexEmptyValue(6,0.0);
   SetIndexLabel(6,"principal");
  
   SetIndexBuffer(7,Fleche_down_2);
   SetIndexStyle(7, DRAW_ARROW);//, STYLE_SOLID,2);
   SetIndexArrow(7,234);
   SetIndexEmptyValue(7,0.0);// SI ON OUBLIE LE EMPTY VALUE NE MARCHE PAS
   SetIndexLabel(7,"intermediaire");

//----
   SetIndexDrawBegin(0,500);
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Bollinger Bands                                                  |
//+------------------------------------------------------------------+
int start()
  {
  
//---- initial zero
//----------------------------------------------------- 
   int i, counted_bars;             int History = 5000;
   counted_bars = IndicatorCounted() ;
   if(counted_bars < 0 ) return(0);
   if(Bars < 500 ) return(0); 
//----------------------------------------------------- 
   if( counted_bars <= 500 )     i = Bars - 50;
   if( counted_bars >  500 )     i = Bars-counted_bars-1;   
   if( i > History )             i = History;      
//------------------------------------------------------- 11 --
   while( i >= 0 )                      
     {
       double atr = iATR(NULL,0 ,500,i);
           
      Upper[i] = iBands(NULL, 0, BBPer,BBDev,BBShift,BBPrix, 1,i);   
      Lower[i] = iBands(NULL, 0, BBPer,BBDev,BBShift,BBPrix, 2,i);   


         Moving_haut[i] =iMA(NULL, 0, 3,0,3,2,i); 
         Moving_bas[i]  =iMA(NULL, 0, 3,0,3,3,i); 
         
      if( Moving_haut[i+1] > Upper[i+1] &&  Moving_haut[i] < Upper[i])
        Fleche_down_1[i] = Moving_haut[i]+ atr; 
      else     Fleche_down_1[i] = 0.0;
  
    if( Moving_bas[i+1] < Lower[i+1] &&  Moving_bas[i] > Lower[i])
        Fleche_up_1[i] = Moving_bas[i] - atr; 
      else     Fleche_up_1[i] = 0.0;
  
     //----
     i--;
     }
//----
   return(0);
  }
//+------------------------------------------------------------------+